Revit.SDK.Samples.DoorSwing.CS.DoorSwingData.UpdateDoorsGeometry C# (CSharp) Method

UpdateDoorsGeometry() public static method

Doors related rooms: update doors' geometry according to its To/From room information.
public static UpdateDoorsGeometry ( System.Windows.Forms.Document doc, bool onlyUpdateSelect ) : void
doc System.Windows.Forms.Document Revit project.
onlyUpdateSelect bool /// true means only update selected doors' information else false. ///
return void
        public static void UpdateDoorsGeometry(Document doc, bool onlyUpdateSelect)
        {
            IEnumerator iter;
             int doorCount = 0;

             if (onlyUpdateSelect) // update doors in select elements
             {
            UIDocument newUIdoc = new UIDocument(doc);
            iter = newUIdoc.Selection.Elements.GetEnumerator();
             }
             else // update all doors in current Revit document
             {
             ElementClassFilter familyInstanceFilter = new ElementClassFilter(typeof(FamilyInstance));
             ElementCategoryFilter doorsCategoryfilter = new ElementCategoryFilter(BuiltInCategory.OST_Doors);
             LogicalAndFilter doorInstancesFilter = new LogicalAndFilter(familyInstanceFilter, doorsCategoryfilter);
             iter = new FilteredElementCollector(doc).WherePasses(doorInstancesFilter).GetElementIterator();
             }

             iter.Reset();
             while (iter.MoveNext())
             {
            // find door instance
            FamilyInstance door = iter.Current as FamilyInstance;

            if (onlyUpdateSelect)
            {
               if (null == door)
               {
                  continue;
               }

               if (null == door.Category)
               {
                  continue;
               }

               if (!door.Category.Name.Equals("Doors"))
               {
                  continue;
               }
            }

            // find one door.
            doorCount++;

            // update one door.
            UpdateFromToRoomofOneDoor(door, true);
            doc.Regenerate();
             }

             if (onlyUpdateSelect)
             {
            System.Windows.Forms.MessageBox.Show("Updated all selected doors (" + doorCount +
                                                 " doors).\r\n (Selection may include miscellaneous elements.)",
                                                 "Door Swing");
             }
             else
             {
            System.Windows.Forms.MessageBox.Show("Updated all doors of this project (" +
                                                 doorCount + " doors).", "Door Swing");
             }
        }

Usage Example

Exemplo n.º 1
0
        /// <summary>
        /// Implement this method as an external command for Revit.
        /// </summary>
        /// <param name="commandData">An object that is passed to the external application
        /// which contains data related to the command,
        /// such as the application object and active view.</param>
        /// <param name="message">A message that can be set by the external application
        /// which will be displayed if a failure or cancellation is returned by
        /// the external command.</param>
        /// <param name="elements">A set of elements to which the external application
        /// can add elements that are to be highlighted in case of failure or cancellation.</param>
        /// <returns>Return the status of the external command.
        /// A result of Succeeded means that the API external method functioned as expected.
        /// Cancelled can be used to signify that the user cancelled the external operation
        /// at some point. Failure should be returned if the application is unable to proceed with
        /// the operation.</returns>
        public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements)
        {
            Autodesk.Revit.UI.Result        returnCode = Autodesk.Revit.UI.Result.Succeeded;
            Autodesk.Revit.UI.UIApplication app        = commandData.Application;
            UIDocument  doc  = app.ActiveUIDocument;
            Transaction tran = new Transaction(doc.Document, "Update Geometry Command");

            tran.Start();

            try
            {
                ElementSet elementSet = new ElementSet();
                foreach (ElementId elementId in doc.Selection.GetElementIds())
                {
                    elementSet.Insert(doc.Document.GetElement(elementId));
                }
                if (elementSet.IsEmpty)
                {
                    DoorSwingData.UpdateDoorsGeometry(doc.Document, false);
                }
                else
                {
                    DoorSwingData.UpdateDoorsGeometry(doc.Document, true);
                }

                returnCode = Autodesk.Revit.UI.Result.Succeeded;
            }
            catch (Exception ex)
            {
                // if there is anything wrong, give error information and return failed.
                message    = ex.Message;
                returnCode = Autodesk.Revit.UI.Result.Failed;
            }

            if (Autodesk.Revit.UI.Result.Succeeded == returnCode)
            {
                tran.Commit();
            }
            else
            {
                tran.RollBack();
            }

            return(returnCode);
        }